/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.66 Revision 1.125
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.66 2010/03/24 14:36:28 yngwin Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.125 2012/04/19 14:52:12 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
37 ;;
38 release)
39 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
40 ;;
41esac
42
43IUSE="aqua debug pch"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 44if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
21else 45 IUSE+=" +exceptions"
22 MY_P=qt-x11-opensource-src-${MY_PV}
23fi 46fi
47if version_is_at_least 4.8; then
48 IUSE+=" c++0x qpa"
49fi
24 50
25HOMEPAGE="http://qt.nokia.com/" 51DEPEND="dev-util/pkgconfig"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz" 52if [[ ${QT4_BUILD_TYPE} == live ]]; then
27 53 DEPEND+=" dev-lang/perl"
28LICENSE="|| ( LGPL-2.1 GPL-3 )" 54fi
29IUSE+=" debug pch aqua"
30 55
31RDEPEND=" 56RDEPEND="
32 !<x11-libs/qt-assistant-${PV} 57 !<x11-libs/qt-assistant-${PV}
33 !>x11-libs/qt-assistant-${PV}-r9999 58 !>x11-libs/qt-assistant-${PV}-r9999
59 !<x11-libs/qt-bearer-${PV}
60 !>x11-libs/qt-bearer-${PV}-r9999
34 !<x11-libs/qt-core-${PV} 61 !<x11-libs/qt-core-${PV}
35 !>x11-libs/qt-core-${PV}-r9999 62 !>x11-libs/qt-core-${PV}-r9999
36 !<x11-libs/qt-dbus-${PV} 63 !<x11-libs/qt-dbus-${PV}
37 !>x11-libs/qt-dbus-${PV}-r9999 64 !>x11-libs/qt-dbus-${PV}-r9999
65 !<x11-libs/qt-declarative-${PV}
66 !>x11-libs/qt-declarative-${PV}-r9999
38 !<x11-libs/qt-demo-${PV} 67 !<x11-libs/qt-demo-${PV}
39 !>x11-libs/qt-demo-${PV}-r9999 68 !>x11-libs/qt-demo-${PV}-r9999
40 !<x11-libs/qt-gui-${PV} 69 !<x11-libs/qt-gui-${PV}
41 !>x11-libs/qt-gui-${PV}-r9999 70 !>x11-libs/qt-gui-${PV}-r9999
42 !<x11-libs/qt-multimedia-${PV} 71 !<x11-libs/qt-multimedia-${PV}
43 !>x11-libs/qt-multimedia-${PV}-r9999 72 !>x11-libs/qt-multimedia-${PV}-r9999
44 !<x11-libs/qt-opengl-${PV} 73 !<x11-libs/qt-opengl-${PV}
45 !>x11-libs/qt-opengl-${PV}-r9999 74 !>x11-libs/qt-opengl-${PV}-r9999
75 !<x11-libs/qt-openvg-${PV}
76 !>x11-libs/qt-openvg-${PV}-r9999
46 !<x11-libs/qt-phonon-${PV} 77 !<x11-libs/qt-phonon-${PV}
47 !>x11-libs/qt-phonon-${PV}-r9999 78 !>x11-libs/qt-phonon-${PV}-r9999
48 !<x11-libs/qt-qt3support-${PV} 79 !<x11-libs/qt-qt3support-${PV}
49 !>x11-libs/qt-qt3support-${PV}-r9999 80 !>x11-libs/qt-qt3support-${PV}-r9999
50 !<x11-libs/qt-script-${PV} 81 !<x11-libs/qt-script-${PV}
63 94
64S=${WORKDIR}/${MY_P} 95S=${WORKDIR}/${MY_P}
65 96
66# @FUNCTION: qt4-build_pkg_setup 97# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 98# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 99# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 100qt4-build_pkg_setup() {
70 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 101 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
71 102
72 # Protect users by not allowing downgrades between releases 103 # Protect users by not allowing downgrades between releases
73 # Downgrading revisions within the same release should be allowed 104 # Downgrading revisions within the same release should be allowed
74 if has_version '>'${CATEGORY}/${P}-r9999 ; then 105 if has_version '>'${CATEGORY}/${P}-r9999; then
75 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 106 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
107 eerror
76 eerror "Sanity check to keep you from breaking your system:" 108 eerror "Sanity check to keep you from breaking your system:"
77 eerror " Downgrading Qt is completely unsupported and will break your system!" 109 eerror " Downgrading Qt is completely unsupported and will break your system!"
110 eerror
78 die "aborting to save your system" 111 die "aborting to save your system"
79 else 112 else
80 ewarn "Downgrading Qt is completely unsupported and will break your system!" 113 ewarn "Downgrading Qt is completely unsupported and will break your system!"
81 fi 114 fi
115 fi
116
117 if [[ ${PN} == qt-webkit ]]; then
118 eshopts_push -s extglob
119 if is-flagq '-g?(gdb)?([1-9])'; then
120 echo
121 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
122 ewarn "You may experience really long compilation times and/or increased memory usage."
123 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
124 ewarn "For more info check out bug #307861"
125 echo
126 fi
127 eshopts_pop
82 fi 128 fi
83 129
84 PATH="${S}/bin${PATH:+:}${PATH}" 130 PATH="${S}/bin${PATH:+:}${PATH}"
85 if [[ ${CHOST} != *-darwin* ]]; then 131 if [[ ${CHOST} != *-darwin* ]]; then
86 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 132 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
92 [[ ${CHOST} == *-apple-darwin* ]] && \ 138 [[ ${CHOST} == *-apple-darwin* ]] && \
93 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 139 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
94 ${QT4_EXTRACT_DIRECTORIES}" 140 ${QT4_EXTRACT_DIRECTORIES}"
95 fi 141 fi
96 142
97 # Make sure ebuilds use the required EAPI
98 if [[ ${EAPI} != [23] ]]; then
99 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
100 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
101 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
102 die "qt4-build eclass requires EAPI=2 or EAPI=3"
103 fi
104
105 if ! version_is_at_least 4.1 $(gcc-version); then 143 if ! version_is_at_least 4.1 $(gcc-version); then
106 ewarn "Using a GCC version lower than 4.1 is not supported!" 144 ewarn "Using a GCC version lower than 4.1 is not supported."
107 fi 145 fi
108} 146}
109 147
110# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 148# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
111# @DESCRIPTION: 149# @DESCRIPTION:
112# Arguments for build_target_directories. Takes the directories, in which the 150# Arguments for build_target_directories. Takes the directories in which the
113# code should be compiled. This is a space-separated list 151# code should be compiled. This is a space-separated list.
114 152
115# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES 153# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
116# @DESCRIPTION: 154# @DESCRIPTION:
117# Space separated list including the directories that will be extracted from Qt 155# Space-separated list including the directories that will be extracted from
118# tarball 156# Qt tarball.
119 157
120# @FUNCTION: qt4-build_src_unpack 158# @FUNCTION: qt4-build_src_unpack
121# @DESCRIPTION: 159# @DESCRIPTION:
122# Unpacks the sources 160# Unpacks the sources.
123qt4-build_src_unpack() { 161qt4-build_src_unpack() {
124 setqtenv 162 setqtenv
125 local target targets= 163
164 case ${QT4_BUILD_TYPE} in
165 live)
166 git-2_src_unpack
167 ;;
168 release)
169 local tarball="${MY_P}.tar.gz" target= targets=
126 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 170 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
127 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 171 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
128 ${QT4_EXTRACT_DIRECTORIES}; do 172 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
173 do
129 targets+=" ${MY_P}/${target}" 174 targets+="${MY_P}/${target} "
130 done 175 done
131 176
132 echo tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 177 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
133 tar xzpf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 178 tar -xzf "${DISTDIR}/${tarball}" ${targets}
179 eend $? || die "failed to unpack"
180 ;;
181 esac
134} 182}
135 183
136# @ECLASS-VARIABLE: PATCHES 184# @ECLASS-VARIABLE: PATCHES
185# @DEFAULT_UNSET
137# @DESCRIPTION: 186# @DESCRIPTION:
138# In case you have patches to apply, specify them in PATCHES variable. Make sure 187# PATCHES array variable containing all various patches to be applied.
139# to specify the full path. This variable is necessary for src_prepare phase. 188# This variable is expected to be defined in global scope of ebuild.
140# example: 189# Make sure to specify the full path. This variable is utilised in
141# PATCHES="${FILESDIR}"/mypatch.patch 190# src_unpack/src_prepare phase, based on EAPI.
142# ${FILESDIR}"/mypatch2.patch"
143# 191#
192# @CODE
193# PATCHES=( "${FILESDIR}/mypatch.patch"
194# "${FILESDIR}/patches_folder/" )
195# @CODE
144 196
145# @FUNCTION: qt4-build_src_prepare 197# @FUNCTION: qt4-build_src_prepare
146# @DESCRIPTION: 198# @DESCRIPTION:
147# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 199# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
148# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 200# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
149qt4-build_src_prepare() { 201qt4-build_src_prepare() {
150 setqtenv 202 setqtenv
151 cd "${S}" 203
204 if [[ ${QT4_BUILD_TYPE} == live ]]; then
205 QTDIR="." ./bin/syncqt || die "syncqt failed"
206 fi
207
208 if version_is_at_least 4.7; then
209 # fix libX11 dependency on non X packages
210 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
211 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
212
213 qt_assistant_cleanup
214 fi
152 215
153 if use aqua; then 216 if use aqua; then
154 # provide a proper macx-g++-64 217 # provide a proper macx-g++-64
155 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 218 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
156 219
157 sed -e '/^CONFIG/s:app_bundle::' \ 220 sed -e '/^CONFIG/s:app_bundle::' \
158 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 221 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
159 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 222 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
160 fi 223 fi
161 224
162 if [[ ${PN} != qt-core ]]; then 225 if [[ ${PN} != qt-core ]]; then
163 skip_qmake_build_patch 226 skip_qmake_build
164 skip_project_generation_patch 227 skip_project_generation
165 symlink_binaries_to_buildtree 228 symlink_binaries_to_buildtree
166 fi 229 fi
167 230
168 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 231 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
169 # qmake bus errors with -O2 but -O3 works 232 # qmake bus errors with -O2 or -O3 but -O1 works
233 # Bug 373061
170 replace-flags -O2 -O3 234 replace-flags -O[23] -O1
171 fi 235 fi
172
173 # Bug 282984 && Bug 295530
174 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\n\1:" \
175 -i configure || die "sed qmake compilers failed"
176 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX):" \
177 -i config.tests/unix/compile.test || die "sed test compilers failed"
178 236
179 # Bug 178652 237 # Bug 178652
180 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 238 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
181 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 239 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
182 append-flags -fno-gcse 240 append-flags -fno-gcse
183 fi 241 fi
184 242
243 if use_if_iuse c++0x; then
244 echo
245 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
246 ewarn "this is an official standard, some of the reverse dependencies"
247 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
248 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
249 ewarn "disabled."
250 echo
251 append-flags -std=c++0x
252 fi
253
185 # Unsupported old gcc versions - hardened needs this :( 254 # Unsupported old gcc versions - hardened needs this :(
186 if [[ $(gcc-major-version) -lt 4 ]] ; then 255 if [[ $(gcc-major-version) -lt 4 ]]; then
187 ewarn "Appending -fno-stack-protector to CXXFLAGS" 256 ewarn "Appending -fno-stack-protector to CXXFLAGS"
188 append-cxxflags -fno-stack-protector 257 append-cxxflags -fno-stack-protector
189 # Bug 253127 258 # Bug 253127
190 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 259 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
191 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 260 -i mkspecs/common/g++.conf || die
192 fi 261 fi
193 262
194 # Bug 261632 263 # Bug 261632
195 if use ppc64; then 264 if use ppc64; then
196 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 265 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
197 append-flags -mminimal-toc 266 append-flags -mminimal-toc
198 fi 267 fi
199 268
269 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
270 sed -e "/^SYSTEM_VARIABLES=/i \
271 CC='$(tc-getCC)'\n\
272 CXX='$(tc-getCXX)'\n\
273 CFLAGS='${CFLAGS}'\n\
274 CXXFLAGS='${CXXFLAGS}'\n\
275 LDFLAGS='${LDFLAGS}'\n" \
276 -i configure \
277 || die "sed SYSTEM_VARIABLES failed"
278
279 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed"
285
286 # Strip predefined CFLAGS from mkspecs (bug 312689)
287 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
288
200 # Bug 172219 289 # Bug 172219
201 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 290 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
202 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
203 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
204 -e "s:X11R6/::" \
205 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
206 291
207 if [[ ${CHOST} != *-darwin* ]]; then 292 if [[ ${CHOST} == *-darwin* ]]; then
208 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
209 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
210 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \
211 -i mkspecs/common/g++.conf || die "sed mkspecs/common/g++.conf failed"
212 else
213 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 293 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
214 # crippled (by design) :/ 294 # crippled (by design) :/
295 local mac_gpp_conf=
296 if [[ -f mkspecs/common/mac-g++.conf ]]; then
297 # qt < 4.8 has mac-g++.conf
298 mac_gpp_conf="mkspecs/common/mac-g++.conf"
299 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
300 # qt >= 4.8 has g++-macx.conf
301 mac_gpp_conf="mkspecs/common/g++-macx.conf"
302 else
303 die "no known conf file for mac found"
304 fi
305 sed \
215 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 306 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
216 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 307 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
217 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 308 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
218 -e "s:-arch\s\w*::g" \ 309 -e "s:-arch\s\w*::g" \
219 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 310 -i ${mac_gpp_conf} \
311 || die "sed ${mac_gpp_conf} failed"
220 312
221 # Fix configure's -arch settings that appear in qmake/Makefile and also 313 # Fix configure's -arch settings that appear in qmake/Makefile and also
222 # fix arch handling (automagically duplicates our -arch arg and breaks 314 # fix arch handling (automagically duplicates our -arch arg and breaks
223 # pch). Additionally disable Xarch support. 315 # pch). Additionally disable Xarch support.
316 local mac_gcc_confs="${mac_gpp_conf}"
317 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
318 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
319 fi
224 sed \ 320 sed \
225 -e "s:-arch i386::" \ 321 -e "s:-arch i386::" \
226 -e "s:-arch ppc::" \ 322 -e "s:-arch ppc::" \
227 -e "s:-arch x86_64::" \ 323 -e "s:-arch x86_64::" \
228 -e "s:-arch ppc64::" \ 324 -e "s:-arch ppc64::" \
229 -e "s:-arch \$i::" \ 325 -e "s:-arch \$i::" \
230 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 326 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
231 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 327 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
232 -e "s:-Xarch_x86_64::g" \ 328 -e "s:-Xarch_x86_64::g" \
233 -e "s:-Xarch_ppc64::g" \ 329 -e "s:-Xarch_ppc64::g" \
234 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 330 -i configure ${mac_gcc_confs} \
331 || die "sed -arch/-Xarch failed"
235 332
236 # On Snow Leopard don't fall back to 10.5 deployment target. 333 # On Snow Leopard don't fall back to 10.5 deployment target.
237 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 334 if [[ ${CHOST} == *-apple-darwin10 ]]; then
238 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 335 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
239 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 336 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
240 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 337 -i configure ${mac_gpp_conf} \
338 || die "sed deployment target failed"
241 fi 339 fi
242 fi 340 fi
243 341
244 # this one is needed for all systems with a separate -liconv, apart from 342 # this one is needed for all systems with a separate -liconv, apart from
245 # Darwin, for which the sources already cater for -liconv 343 # Darwin, for which the sources already cater for -liconv
246 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 344 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
247 sed \ 345 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
248 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
249 -i config.tests/unix/iconv/iconv.pro \ 346 -i config.tests/unix/iconv/iconv.pro \
250 || die "sed on iconv.pro failed" 347 || die "sed iconv.pro failed"
251 fi 348 fi
252 349
253 # we need some patches for Solaris 350 # we need some patches for Solaris
254 sed -i \
255 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 351 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
256 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 352 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
257 # use GCC over SunStudio 353 # use GCC over SunStudio
258 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 354 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
259 # don't flirt with non-Prefix stuff, we're quite possessive 355 # do not flirt with non-Prefix stuff, we're quite possessive
260 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 356 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
261 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 357 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
262 358
263 base_src_prepare 359 base_src_prepare
264} 360}
266# @FUNCTION: qt4-build_src_configure 362# @FUNCTION: qt4-build_src_configure
267# @DESCRIPTION: 363# @DESCRIPTION:
268# Default configure phase 364# Default configure phase
269qt4-build_src_configure() { 365qt4-build_src_configure() {
270 setqtenv 366 setqtenv
271 myconf="$(standard_configure_options) ${myconf}" 367
368 local conf="
369 -prefix ${QTPREFIXDIR}
370 -bindir ${QTBINDIR}
371 -libdir ${QTLIBDIR}
372 -docdir ${QTDOCDIR}
373 -headerdir ${QTHEADERDIR}
374 -plugindir ${QTPLUGINDIR}
375 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
376 -datadir ${QTDATADIR}
377 -translationdir ${QTTRANSDIR}
378 -sysconfdir ${QTSYSCONFDIR}
379 -examplesdir ${QTEXAMPLESDIR}
380 -demosdir ${QTDEMOSDIR}
381 -opensource -confirm-license
382 -shared -fast -largefile -stl -verbose
383 -nomake examples -nomake demos"
384
385 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
386 # $(tc-arch). Therefore we convert it to supported values.
387 case "$(tc-arch)" in
388 amd64|x64-*) conf+=" -arch x86_64" ;;
389 ppc-macos) conf+=" -arch ppc" ;;
390 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
391 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
392 x86-macos) conf+=" -arch x86" ;;
393 x86|x86-*) conf+=" -arch i386" ;;
394 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
395 hppa|sh) conf+=" -arch generic" ;;
396 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
397 esac
398
399 conf+=" -platform $(qt_mkspecs_dir)"
400
401 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
402
403 # debug/release
404 if use debug; then
405 conf+=" -debug"
406 else
407 conf+=" -release"
408 fi
409 conf+=" -no-separate-debug-info"
410
411 # exceptions USE flag
412 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
413
414 # disable RPATH on Qt >= 4.8 (bug 380415)
415 version_is_at_least 4.8 && conf+=" -no-rpath"
416
417 # precompiled headers don't work on hardened, where the flag is masked
418 conf+=" $(qt_use pch)"
419
420 # -reduce-relocations
421 # This flag seems to introduce major breakage to applications,
422 # mostly to be seen as a core dump with the message "QPixmap: Must
423 # construct a QApplication before a QPaintDevice" on Solaris.
424 # -- Daniel Vergien
425 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
272 426
273 # this one is needed for all systems with a separate -liconv, apart from 427 # this one is needed for all systems with a separate -liconv, apart from
274 # Darwin, for which the sources already cater for -liconv 428 # Darwin, for which the sources already cater for -liconv
275 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 429 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
276 myconf+=" -liconv" 430 conf+=" -liconv"
431 fi
277 432
278 if has glib ${IUSE//+} && use glib; then 433 if use_if_iuse glib; then
279 # use -I, -L and -l from configure
280 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 434 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
281 # avoid the -pthread argument 435 # avoid the -pthread argument
282 myconf+=" ${glibflags//-pthread}" 436 conf+=" ${glibflags//-pthread}"
283 unset glibflags 437 unset glibflags
284 fi 438 fi
285 439
440 if use_if_iuse qpa; then
441 echo
442 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
443 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
444 ewarn "disable it before reporting any bugs related to this useflag."
445 echo
446 conf+=" -qpa"
447 fi
448
286 if use aqua ; then 449 if use aqua; then
287 # On (snow) leopard use the new (frameworked) cocoa code. 450 # On (snow) leopard use the new (frameworked) cocoa code.
288 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 451 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
289 myconf+=" -cocoa -framework" 452 conf+=" -cocoa -framework"
453 # We need the source's headers, not the installed ones.
454 conf+=" -I${S}/include"
455 # Add hint for the framework location.
456 conf+=" -F${QTLIBDIR}"
290 457
291 # We are crazy and build cocoa + qt3support :-) 458 # We are crazy and build cocoa + qt3support :-)
292 if use qt3support; then 459 if use qt3support; then
293 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 460 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
294 -i configure 461 -i configure || die
295 fi 462 fi
296 463 else
297 # We need the source's headers, not the installed ones. 464 conf+=" -no-framework"
298 myconf+=" -I${S}/include"
299
300 # Add hint for the framework location.
301 myconf+=" -F${QTLIBDIR}"
302 fi 465 fi
303 else 466 else
304 # freetype2 include dir is non-standard, thus include it on configure 467 # freetype2 include dir is non-standard, thus pass it to configure
305 # use -I from configure
306 myconf+=" $(pkg-config --cflags freetype2)" 468 conf+=" $(pkg-config --cflags-only-I freetype2)"
307 fi 469 fi
308 470
471 conf+=" ${myconf}"
472 myconf=
473
309 echo ./configure ${myconf} 474 echo ./configure ${conf}
310 ./configure ${myconf} || die "./configure failed" 475 ./configure ${conf} || die "./configure failed"
311 myconf="" 476
477 prepare_directories ${QT4_TARGET_DIRECTORIES}
312} 478}
313 479
314# @FUNCTION: qt4-build_src_compile 480# @FUNCTION: qt4-build_src_compile
481# @DESCRIPTION:
315# @DESCRIPTION: Actual compile phase 482# Actual compile phase
316qt4-build_src_compile() { 483qt4-build_src_compile() {
317 setqtenv 484 setqtenv
318 485
319 build_directories ${QT4_TARGET_DIRECTORIES} 486 build_directories ${QT4_TARGET_DIRECTORIES}
320} 487}
321 488
489# @FUNCTION: qt4-build_src_test
490# @DESCRIPTION:
491# Runs tests only in target directories.
492qt4-build_src_test() {
493 # QtMultimedia does not have any test suite (bug #332299)
494 [[ ${PN} == qt-multimedia ]] && return
495
496 for dir in ${QT4_TARGET_DIRECTORIES}; do
497 emake -j1 check -C ${dir}
498 done
499}
500
322# @FUNCTION: fix_includes 501# @FUNCTION: fix_includes
323# @DESCRIPTION: 502# @DESCRIPTION:
324# For MacOSX we need to add some symlinks when frameworks are 503# For MacOS X we need to add some symlinks when frameworks are
325# being used, to avoid complications with some more or less stupid packages. 504# being used, to avoid complications with some more or less stupid packages.
326fix_includes() { 505fix_includes() {
327 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 506 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
328 # Some packages tend to include <Qt/...> 507 # Some packages tend to include <Qt/...>
329 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 508 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
330 509
331 # Fake normal headers when frameworks are installed... eases life later on 510 # Fake normal headers when frameworks are installed... eases life later on
332 local dest f 511 local dest f h
333 for frw in "${D}${QTLIBDIR}"/*.framework; do 512 for frw in "${D}${QTLIBDIR}"/*.framework; do
334 [[ -e "${frw}"/Headers ]] || continue 513 [[ -e "${frw}"/Headers ]] || continue
335 f=$(basename ${frw}) 514 f=$(basename ${frw})
336 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 515 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
337 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 516 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
349# @DESCRIPTION: 528# @DESCRIPTION:
350# Perform the actual installation including some library fixes. 529# Perform the actual installation including some library fixes.
351qt4-build_src_install() { 530qt4-build_src_install() {
352 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 531 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
353 setqtenv 532 setqtenv
533
354 install_directories ${QT4_TARGET_DIRECTORIES} 534 install_directories ${QT4_TARGET_DIRECTORIES}
355 install_qconfigs 535 install_qconfigs
356 fix_library_files 536 fix_library_files
357 fix_includes 537 fix_includes
538
539 # remove .la files since we are building only shared Qt libraries
540 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
358} 541}
359 542
360# @FUNCTION: setqtenv 543# @FUNCTION: setqtenv
544# @INTERNAL
361setqtenv() { 545setqtenv() {
362 # Set up installation directories 546 # Set up installation directories
363 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
364 QTPREFIXDIR=${EPREFIX}/usr 547 QTPREFIXDIR=${EPREFIX}/usr
365 QTBINDIR=${EPREFIX}/usr/bin 548 QTBINDIR=${EPREFIX}/usr/bin
366 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 549 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
367 QMAKE_LIBDIR_QT=${QTLIBDIR}
368 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 550 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
369 QTDATADIR=${EPREFIX}/usr/share/qt4
370 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 551 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
371 QTHEADERDIR=${EPREFIX}/usr/include/qt4 552 QTHEADERDIR=${EPREFIX}/usr/include/qt4
372 QTPLUGINDIR=${QTLIBDIR}/plugins 553 QTPLUGINDIR=${QTLIBDIR}/plugins
554 QTIMPORTDIR=${QTLIBDIR}/imports
555 QTDATADIR=${EPREFIX}/usr/share/qt4
556 QTTRANSDIR=${QTDATADIR}/translations
373 QTSYSCONFDIR=${EPREFIX}/etc/qt4 557 QTSYSCONFDIR=${EPREFIX}/etc/qt4
374 QTTRANSDIR=${QTDATADIR}/translations
375 QTEXAMPLESDIR=${QTDATADIR}/examples 558 QTEXAMPLESDIR=${QTDATADIR}/examples
376 QTDEMOSDIR=${QTDATADIR}/demos 559 QTDEMOSDIR=${QTDATADIR}/demos
560 QMAKE_LIBDIR_QT=${QTLIBDIR}
377 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 561 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
562
378 PLATFORM=$(qt_mkspecs_dir) 563 PLATFORM=$(qt_mkspecs_dir)
379 564
380 unset QMAKESPEC 565 unset QMAKESPEC
381} 566}
382 567
383# @FUNCTION: standard_configure_options
384# @DESCRIPTION:
385# Sets up some standard configure options, like libdir (if necessary), whether
386# debug info is wanted or not.
387standard_configure_options() {
388 local myconf=
389
390 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
391
392 # Disable visibility explicitly if gcc version isn't 4
393 if [[ $(gcc-major-version) -lt 4 ]]; then
394 myconf+=" -no-reduce-exports"
395 fi
396
397 # precompiled headers doesn't work on hardened, where the flag is masked.
398 myconf+=" $(qt_use pch)"
399
400 if use debug; then
401 myconf+=" -debug"
402 else
403 myconf+=" -release"
404 fi
405 myconf+=" -no-separate-debug-info"
406
407 use aqua && myconf+=" -no-framework"
408
409 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
410 # $(tc-arch). Therefore we convert it to supported values.
411 case "$(tc-arch)" in
412 amd64|x64-*) myconf+=" -arch x86_64" ;;
413 ppc-macos) myconf+=" -arch ppc" ;;
414 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
415 sparc|sparc-*) myconf+=" -arch sparc" ;;
416 x86-macos) myconf+=" -arch x86" ;;
417 x86|x86-*) myconf+=" -arch i386" ;;
418 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
419 hppa|sh) myconf+=" -arch generic" ;;
420 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
421 esac
422
423 # 4.5: build everything but qt-xmlpatterns w/o exceptions
424 # 4.6: exceptions USE flag
425 local exceptions="-exceptions"
426 case "${PV}" in
427 4.5.*)
428 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
429 ;;
430 *)
431 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
432 ;;
433 esac
434
435 # note about -reduce-relocations:
436 # That flag seems to introduce major breakage to applications,
437 # mostly to be seen as a core dump with the message "QPixmap: Must
438 # construct a QApplication before a QPaintDevice" on Solaris
439 # -- Daniel Vergien
440 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
441
442 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
443 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
444 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
445 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
446 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
447 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
448 ${exceptions}
449 -nomake examples -nomake demos"
450
451 echo "${myconf}"
452}
453
454# @FUNCTION: build_directories 568# @FUNCTION: prepare_directories
455# @USAGE: < directories > 569# @USAGE: < directories >
570# @INTERNAL
456# @DESCRIPTION: 571# @DESCRIPTION:
457# Compiles the code in $QT4_TARGET_DIRECTORIES 572# Generates Makefiles for the given list of directories.
458build_directories() { 573prepare_directories() {
459 for x in "$@"; do 574 for x in "$@"; do
460 pushd "${S}"/${x} >/dev/null 575 pushd "${S}"/${x} >/dev/null || die
576 einfo "Running qmake in: ${x}"
461 # avoid running over the maximum argument number, bug #299810 577 # avoid running over the maximum argument number, bug #299810
462 { 578 {
463 echo "${S}"/mkspecs/common/*.conf 579 echo "${S}"/mkspecs/common/*.conf
464 find "${S}" -name '*.pr[io]' 580 find "${S}" -name '*.pr[io]'
465 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 581 } | xargs sed -i \
582 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
583 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
584 || die
466 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 585 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
467 emake CC="@echo compiling \$< && $(tc-getCC)" \
468 CXX="@echo compiling \$< && $(tc-getCXX)" \
469 LINK="@echo linking \$@ && $(tc-getCXX)" || die "emake failed"
470 popd >/dev/null 586 popd >/dev/null || die
587 done
588}
589
590
591# @FUNCTION: build_directories
592# @USAGE: < directories >
593# @INTERNAL
594# @DESCRIPTION:
595# Compiles the code in the given list of directories.
596build_directories() {
597 for x in "$@"; do
598 pushd "${S}"/${x} >/dev/null || die
599 emake CC="$(tc-getCC)" \
600 CXX="$(tc-getCXX)" \
601 LINK="$(tc-getCXX)" || die "emake failed"
602 popd >/dev/null || die
471 done 603 done
472} 604}
473 605
474# @FUNCTION: install_directories 606# @FUNCTION: install_directories
475# @USAGE: < directories > 607# @USAGE: < directories >
608# @INTERNAL
476# @DESCRIPTION: 609# @DESCRIPTION:
477# run emake install in the given directories, which are separated by spaces 610# Runs emake install in the given directories, which are separated by spaces.
478install_directories() { 611install_directories() {
479 for x in "$@"; do 612 for x in "$@"; do
480 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 613 pushd "${S}"/${x} >/dev/null || die
481 emake INSTALL_ROOT="${D}" install || die "emake install failed" 614 emake INSTALL_ROOT="${D}" install || die "emake install failed"
482 popd >/dev/null || die "Can't popd from ${S}/${x}" 615 popd >/dev/null || die
483 done 616 done
484} 617}
485 618
486# @ECLASS-VARIABLE: QCONFIG_ADD 619# @ECLASS-VARIABLE: QCONFIG_ADD
487# @DESCRIPTION: 620# @DESCRIPTION:
497# @DESCRIPTION: 630# @DESCRIPTION:
498# List variables that should be defined at the top of QtCore/qconfig.h 631# List variables that should be defined at the top of QtCore/qconfig.h
499: ${QCONFIG_DEFINE:=} 632: ${QCONFIG_DEFINE:=}
500 633
501# @FUNCTION: install_qconfigs 634# @FUNCTION: install_qconfigs
635# @INTERNAL
636# @DESCRIPTION:
502# @DESCRIPTION: Install gentoo-specific mkspecs configurations 637# Install gentoo-specific mkspecs configurations.
503install_qconfigs() { 638install_qconfigs() {
504 local x 639 local x
505 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 640 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
506 for x in QCONFIG_ADD QCONFIG_REMOVE; do 641 for x in QCONFIG_ADD QCONFIG_REMOVE; do
507 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 642 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
518 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 653 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
519 fi 654 fi
520} 655}
521 656
522# @FUNCTION: generate_qconfigs 657# @FUNCTION: generate_qconfigs
523# @DESCRIPTION: Generates gentoo-specific configurations 658# @INTERNAL
659# @DESCRIPTION:
660# Generates gentoo-specific qconfig.{h,pri}.
524generate_qconfigs() { 661generate_qconfigs() {
525 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 662 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
526 local x qconfig_add qconfig_remove qconfig_new 663 local x qconfig_add qconfig_remove qconfig_new
527 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 664 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
528 [[ -f ${x} ]] || continue 665 [[ -f ${x} ]] || continue
529 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 666 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
530 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 667 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
542 679
543 # generate list of QT_CONFIG entries from the existing list 680 # generate list of QT_CONFIG entries from the existing list
544 # including qconfig_add and excluding qconfig_remove 681 # including qconfig_add and excluding qconfig_remove
545 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 682 for x in $(sed -n 's/^QT_CONFIG +=//p' \
546 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 683 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
547 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 684 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
548 done 685 done
549 686
550 # replace the existing QT_CONFIG list with qconfig_new 687 # replace the existing QT_CONFIG list with qconfig_new
551 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 688 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
552 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 689 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
576 fi 713 fi
577 fi 714 fi
578} 715}
579 716
580# @FUNCTION: qt4-build_pkg_postrm 717# @FUNCTION: qt4-build_pkg_postrm
718# @DESCRIPTION:
581# @DESCRIPTION: Generate configurations when the package is completely removed 719# Regenerate configuration when the package is completely removed.
582qt4-build_pkg_postrm() { 720qt4-build_pkg_postrm() {
583 generate_qconfigs 721 generate_qconfigs
584} 722}
585 723
586# @FUNCTION: qt4-build_pkg_postinst 724# @FUNCTION: qt4-build_pkg_postinst
725# @DESCRIPTION:
587# @DESCRIPTION: Generate configuration, plus throws a message about possible 726# Regenerate configuration, plus throw a message about possible
588# breakages and proposed solutions. 727# breakages and proposed solutions.
589qt4-build_pkg_postinst() { 728qt4-build_pkg_postinst() {
590 generate_qconfigs 729 generate_qconfigs
591} 730}
592 731
593# @FUNCTION: skip_qmake_build_patch 732# @FUNCTION: skip_qmake_build
733# @INTERNAL
594# @DESCRIPTION: 734# @DESCRIPTION:
595# Don't need to build qmake, as it's already installed from qt-core 735# Patches configure to skip qmake compilation, as it's already installed by qt-core.
596skip_qmake_build_patch() { 736skip_qmake_build() {
597 # Don't need to build qmake, as it's already installed from qt-core
598 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 737 sed -i -e "s:if true:if false:g" "${S}"/configure || die
599} 738}
600 739
601# @FUNCTION: skip_project_generation_patch 740# @FUNCTION: skip_project_generation
741# @INTERNAL
602# @DESCRIPTION: 742# @DESCRIPTION:
603# Exit the script early by throwing in an exit before all of the .pro files are scanned 743# Exit the script early by throwing in an exit before all of the .pro files are scanned.
604skip_project_generation_patch() { 744skip_project_generation() {
605 # Exit the script early by throwing in an exit before all of the .pro files are scanned
606 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 745 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
607 -i "${S}"/configure || die "Sed failed"
608} 746}
609 747
610# @FUNCTION: symlink_binaries_to_buildtree 748# @FUNCTION: symlink_binaries_to_buildtree
749# @INTERNAL
611# @DESCRIPTION: 750# @DESCRIPTION:
612# Symlink generated binaries to buildtree so they can be used during compilation 751# Symlinks generated binaries to buildtree, so they can be used during compilation time.
613# time
614symlink_binaries_to_buildtree() { 752symlink_binaries_to_buildtree() {
615 for bin in qmake moc uic rcc; do 753 for bin in qmake moc uic rcc; do
616 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 754 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
617 done 755 done
618} 756}
619 757
620# @FUNCTION: fix_library_files 758# @FUNCTION: fix_library_files
759# @INTERNAL
621# @DESCRIPTION: 760# @DESCRIPTION:
622# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 761# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
623# moves the *.pc-files into the pkgconfig directory 762# moves the *.pc files into the pkgconfig directory.
624fix_library_files() { 763fix_library_files() {
764 local libfile
625 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 765 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
626 if [[ -e ${libfile} ]]; then 766 if [[ -e ${libfile} ]]; then
627 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 767 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
628 fi 768 fi
629 done 769 done
630 770
631 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 771 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
632 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 772 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
633 if [[ -e ${libfile} ]]; then 773 if [[ -e ${libfile} ]]; then
634 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 774 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
635 775
636 # Move .pc files into the pkgconfig directory 776 # Move .pc files into the pkgconfig directory
637 dodir ${QTPCDIR#${EPREFIX}} 777 dodir ${QTPCDIR#${EPREFIX}}
638 mv ${libfile} "${D}"/${QTPCDIR}/ \ 778 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
639 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
640 fi 779 fi
641 done 780 done
642 781
643 # Don't install an empty directory 782 # Don't install an empty directory
644 rmdir "${D}"/${QTLIBDIR}/pkgconfig 783 rmdir "${D}"/${QTLIBDIR}/pkgconfig
645} 784}
646 785
647# @FUNCTION: qt_use 786# @FUNCTION: qt_use
648# @USAGE: < flag > [ feature ] [ enableval ] 787# @USAGE: < flag > [ feature ] [ enableval ]
649# @DESCRIPTION: 788# @DESCRIPTION:
650# This will echo "${enableval}-${feature}" if <flag> is enabled, or 789# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
651# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 790# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
652# will be used for that. If [enableval] is not specified, it omits the 791# will be used for that. If [enableval] is not specified, it omits the
653# assignment-part 792# "-${enableval}" part.
654qt_use() { 793qt_use() {
655 local flag=$1 794 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
656 local feature=$1
657 local enableval=
658
659 [[ -n $2 ]] && feature=$2
660 [[ -n $3 ]] && enableval=-$3
661
662 if use ${flag}; then
663 echo "${enableval}-${feature}"
664 else
665 echo "-no-${feature}"
666 fi
667} 795}
668 796
669# @FUNCTION: qt_mkspecs_dir 797# @FUNCTION: qt_mkspecs_dir
670# @RETURN: the specs-directory w/o path 798# @RETURN: the specs-directory w/o path
671# @DESCRIPTION: 799# @DESCRIPTION:
672# Allows us to define which mkspecs dir we want to use. 800# Allows us to define which mkspecs dir we want to use.
673qt_mkspecs_dir() { 801qt_mkspecs_dir() {
674 # Allows us to define which mkspecs dir we want to use.
675 local spec 802 local spec=
676 803
677 case ${CHOST} in 804 case "${CHOST}" in
678 *-freebsd*|*-dragonfly*) 805 *-freebsd*|*-dragonfly*)
679 spec=freebsd ;; 806 spec=freebsd ;;
680 *-openbsd*) 807 *-openbsd*)
681 spec=openbsd ;; 808 spec=openbsd ;;
682 *-netbsd*) 809 *-netbsd*)
693 *-solaris*) 820 *-solaris*)
694 spec=solaris ;; 821 spec=solaris ;;
695 *-linux-*|*-linux) 822 *-linux-*|*-linux)
696 spec=linux ;; 823 spec=linux ;;
697 *) 824 *)
698 die "Unknown CHOST, no platform choosen." 825 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
699 esac 826 esac
700 827
701 CXX=$(tc-getCXX) 828 case "$(tc-getCXX)" in
702 if [[ ${CXX} == *g++* ]]; then 829 *g++*)
703 spec+=-g++ 830 spec+=-g++ ;;
704 elif [[ ${CXX} == *icpc* ]]; then 831 *icpc*)
705 spec+=-icc 832 spec+=-icc ;;
706 else 833 *)
707 die "Unknown compiler ${CXX}." 834 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
708 fi 835 esac
709 if [[ -n ${LIBDIR/lib} ]]; then
710 spec+=-${LIBDIR/lib}
711 fi
712 836
713 # Add -64 for 64bit profiles 837 # Add -64 for 64bit profiles
714 if use x64-freebsd || 838 if use x64-freebsd ||
715 use amd64-linux || 839 use amd64-linux ||
716 use x64-macos || 840 use x64-macos ||
721 fi 845 fi
722 846
723 echo "${spec}" 847 echo "${spec}"
724} 848}
725 849
850# @FUNCTION: qt_assistant_cleanup
851# @INTERNAL
852# @DESCRIPTION:
853# Tries to clean up tools.pro for qt-assistant ebuilds.
854# Meant to be called in src_prepare().
855# Since Qt 4.7.4 this function is a no-op.
856qt_assistant_cleanup() {
857 # apply patching to qt-assistant ebuilds only
858 [[ ${PN} != qt-assistant ]] && return
859
860 # no longer needed for 4.7.4 and later
861 version_is_at_least 4.7.4 && return
862
863 # different versions (and branches...) may need different handling,
864 # add a case if you need special handling
865 case "${MY_PV_EXTRA}" in
866 *kde-qt*)
867 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
868 -e "/mac/,/^embedded.*makeqpf$/d" \
869 -i tools/tools.pro || die "patching tools.pro failed"
870 ;;
871 *)
872 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
873 -e "/mac/,/^embedded.*makeqpf$/d" \
874 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
875 -i tools/tools.pro || die "patching tools.pro failed"
876 ;;
877 esac
878}
879
880# @FUNCTION: qt_nolibx11
881# @INTERNAL
882# @DESCRIPTION:
883# Ignore X11 tests for packages that don't need X libraries installed.
884qt_nolibx11() {
885 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
886 die "x11 check sed failed"
887}
888
726EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst 889EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.66  
changed lines
  Added in v.1.125

  ViewVC Help
Powered by ViewVC 1.1.20